// Distributed under the MIT software license, see the accompanying
// file LICENSE or http://www.opensource.org/licenses/mit-license.php.

%include "stdint.i"
%include "carrays.i"
%include "cdata.i"
%include "std_vector.i"
%include "std_string.i"
%include "stl.i"
%include "std_except.i"
%include "std_shared_ptr.i"
%include "exception.i"

%array_class(unsigned char, ucharCArray)
%array_class(uint, uintCArray)
%array_class(uint32_t, uint32CArray)

namespace std {
  %template(intVector) vector<int>;
  %template(uintVector) vector<unsigned int>;
  %template(ucharVector) vector<unsigned char>;
  %template(charVector) vector<char>;
  %template(doubleVector) vector<double>;
  %template(_string_list) vector<string>;
  %template(_string_list_list) vector<vector<unsigned char>>;
}

%module(directors="1") pyqryptonight
%{
    #include "pow/powhelper.h"
    #include "misc/strbignum.h"
    #include "qryptonight/qryptonight.h"
    #include "qryptonight/qryptominer.h"
%}

%feature("director") Qryptominer;

%include "pow/powhelper.h"
%include "misc/strbignum.h"
%include "qryptonight/qryptonight.h"
%include "qryptonight/qryptominer.h"

